Index: s390-tools-sles11/dasdview/dasdview.c
===================================================================
--- s390-tools-sles11.orig/dasdview/dasdview.c
+++ s390-tools-sles11/dasdview/dasdview.c
@@ -74,7 +74,7 @@ dasdview_usage(void)
 	printf("\nprints DASD information:\n\n");
 	printf("dasdview [-b begin] [-s size] [-1|-2] \n"
 	       "         [-i] [-x] [-j]\n"
-	       "         [-l] [-t {info|f1|f4|f5|f7|all}] \n"
+	       "         [-l] [-t {info|f1|f4|f5|f7|f8|f9|all}] \n"
 	       "         [-h] [-v] \n"
 	       "         {-n devno|-f node}\n"
 	       "\nwhere:\n"
@@ -91,6 +91,7 @@ dasdview_usage(void)
 	       "-j: prints the volume serial number (volume identifier)\n"
 	       "-l: prints information about the volume label\n"
 	       "-t: prints the table of content (VTOC)\n"
+	       "-c: prints the characteristics of a device\n"
 	       "-h: prints this usage text\n"
 	       "-v: prints the version number\n"
 	       "-n: specifies the device by a device number (needs devfs)\n"
@@ -168,6 +169,7 @@ static void
 dasdview_get_info(dasdview_info_t *info)
 {
 	int fd;
+	u_int64_t device_size;
 
 	fd = open(info->device, O_RDONLY);
 	if (fd == -1)
@@ -199,6 +201,16 @@ dasdview_get_info(dasdview_info_t *info)
 		exit(-1);
 	}
 
+	if (ioctl(fd, BLKGETSIZE64, &device_size) != 0) {
+	        close(fd);
+		zt_error_print("dasdview: ioctl error\n" \
+			"Could not retrieve device size information.\n");
+		exit(-1);
+	}
+
+	info->hw_cylinders = ((device_size / info->blksize)
+			      / info->geo.sectors) / info->geo.heads;
+
 	/* get disk information */
 	if (ioctl(fd, BIODASDINFO2, &info->dasd_info) == 0) {
 		info->dasd_info_version = 2;
@@ -308,8 +320,8 @@ dasdview_print_general_info(dasdview_inf
 	printf("\n--- DASD geometry ----------------------------" \
 	       "---------------------------------\n");
 	printf("number of cylinders    : hex %x  \tdec %d\n",
-	       info->geo.cylinders,
-	       info->geo.cylinders);
+	       info->hw_cylinders,
+	       info->hw_cylinders);
 	printf("tracks per cylinder    : hex %x  \tdec %d\n",
 	       info->geo.heads,
 	       info->geo.heads);
@@ -490,7 +502,8 @@ dasdview_print_vlabel(dasdview_info_t *i
 	else
 		printf("\n                                 " \
 		       "(cyl %d, trk %d, blk %d)\n\n",
-		       vlabel.vtoc.cc, vlabel.vtoc.hh, vlabel.vtoc.b);
+		       vtoc_get_cyl_from_cchhb(&vlabel.vtoc),
+		       vtoc_get_head_from_cchhb(&vlabel.vtoc), vlabel.vtoc.b);
 
 	bzero(s5, 6); bzero(t5, 6); strncpy((char *)s5, vlabel.res1, 5);
 	printf("reserved                : ascii  '%5s'\n", s5);
@@ -539,13 +552,13 @@ dasdview_print_vlabel(dasdview_info_t *i
 		if ((i+1)%8 == 0) printf(" ");
 	}
 
-	bzero(s29, 30); strncpy(s29, vlabel.res3, 29);
-	printf("\n\nreserved                : ascii  '%29s'\n", s29);
+	bzero(s29, 30); strncpy(s29, vlabel.res3, 28);
+	printf("\n\nreserved                : ascii  '%28s'\n", s29);
 	bzero(t29, 30);
-	vtoc_ebcdic_dec(s29, t29, 29);
-	printf("                          ebcdic '%29s'\n", t29);
+	vtoc_ebcdic_dec(s29, t29, 28);
+	printf("                          ebcdic '%28s'\n", t29);
 	printf("                          hex    ");
-	for (i=0; i<29; i++)
+	for (i=0; i<28; i++)
 	{
 		printf("%02x", s29[i]);
 		if ((i+1)%4 == 0) printf(" ");
@@ -553,6 +566,18 @@ dasdview_print_vlabel(dasdview_info_t *i
 		if ((i+1)%16 == 0) printf("\n                " \
 					  "                 ");
 	}
+
+	bzero(s4, 5); bzero(t4, 5); s4[0] = vlabel.ldl_version;
+	printf("\n\nldl_version             : ascii  '%1s'\n", s4);
+	vtoc_ebcdic_dec((char *)s4, (char *)t4, 1);
+	printf("                        : ebcdic '%1s'\n", t4);
+	printf("                        : hex    %02x", s4[0]);
+
+	printf("\n\nformatted_blocks        : dec %llu",
+	       vlabel.formatted_blocks);
+	printf("\n                        : hex %016llx",
+	       vlabel.formatted_blocks);
+
 	printf("\n");
 }
 
@@ -586,7 +611,8 @@ dasdview_read_vtoc(dasdview_info_t *info
 {
         volume_label_t vlabel;
 	format1_label_t tmp;
-	unsigned long pos, vtocblk, maxblk;
+	unsigned long maxblk, pos;
+	u_int64_t vtocblk;
 	int i;
 
 	pos = info->dasd_info.label_block * info->blksize;
@@ -606,10 +632,18 @@ dasdview_read_vtoc(dasdview_info_t *info
 		exit(-1);
 	}
 
-	vtocblk = vlabel.vtoc.cc * info->geo.heads +
-		vlabel.vtoc.hh * info->geo.sectors +
-		vlabel.vtoc.b;
-
+	vtocblk = (u_int64_t) vtoc_get_cyl_from_cchhb(&vlabel.vtoc) *
+		info->geo.heads * info->geo.sectors +
+                vtoc_get_head_from_cchhb(&vlabel.vtoc) * info->geo.sectors +
+                vlabel.vtoc.b;
+
+	/*
+	 * geo.cylinders is the minimum of hw_cylinders and LV_COMPAT_CYL
+	 * Actually the vtoc should be located in in the first 65k-1 tracks
+         * so this check could be even more restrictive, but it doesn't
+         * hurt the way it is. Linux cdl format restricts the vtoc to
+         * the first two tracks anyway.
+	 */
 	maxblk = info->geo.cylinders * info->geo.heads * info->geo.sectors;
 
 	if ((vtocblk <= 0) || (vtocblk > maxblk))
@@ -640,28 +674,37 @@ dasdview_read_vtoc(dasdview_info_t *info
 	        pos += info->blksize;
 	        vtoc_read_label(info->device, pos, &tmp, NULL, NULL, NULL);
 
-		switch (tmp.DS1FMTID)
-		{
-		  case 0xf1:
-		          memcpy(&info->f1[info->f1c], &tmp,
-				 sizeof(format1_label_t));
-		          info->f1c++;
-		          break;
-		  case 0xf4:
-		          info->f4c++;
-		          break;
-		  case 0xf5:
-		          memcpy(&info->f5, &tmp, sizeof(format1_label_t));
-		          info->f5c++;
-		          break;
-		  case 0xf7:
-		          memcpy(&info->f7, &tmp, sizeof(format1_label_t));
-		          info->f7c++;
-		          break;
-		  case 0x00:
-		          break;
-		  default:
-			  printf("Unknown label in VTOC detected (id=%x)\n",
+		switch (tmp.DS1FMTID) {
+		case 0xf1:
+			memcpy(&info->f1[info->f1c], &tmp,
+			       sizeof(format1_label_t));
+			info->f1c++;
+			break;
+		case 0xf4:
+			info->f4c++;
+			break;
+		case 0xf5:
+			memcpy(&info->f5, &tmp, sizeof(format1_label_t));
+			info->f5c++;
+			break;
+		case 0xf7:
+			memcpy(&info->f7, &tmp, sizeof(format1_label_t));
+			info->f7c++;
+			break;
+		case 0xf8:
+			memcpy(&info->f8[info->f8c], &tmp,
+			       sizeof(format1_label_t));
+			info->f8c++;
+			break;
+		case 0xf9:
+			memcpy(&info->f9[info->f9c], &tmp,
+			       sizeof(format1_label_t));
+			info->f9c++;
+			break;
+		case 0x00:
+			break;
+		default:
+			printf("Unknown label in VTOC detected (id=%x)\n",
 				 tmp.DS1FMTID);
 		}
 	}
@@ -688,13 +731,49 @@ dasdview_read_vtoc(dasdview_info_t *info
 	}
 }
 
+static void dasdview_print_format1_8_short_info(format1_label_t *f1,
+						struct hd_geometry *geo)
+{
+	char s6[7], s13[14], s44[45];
+	unsigned long track_low , track_up;
 
-static void
-dasdview_print_vtoc_info(dasdview_info_t *info)
+	bzero(s44, 45);
+	strncpy(s44, f1->DS1DSNAM, 44);
+	vtoc_ebcdic_dec(s44, s44, 44);
+	bzero(s6, 7);
+	strncpy(s6, (char *)f1->DS1DSSN, 6);
+	vtoc_ebcdic_dec(s6, s6, 6);
+	bzero(s13, 14);
+	strncpy(s13, (char *)f1->DS1SYSCD, 13);
+	vtoc_ebcdic_dec(s13, s13, 13);
+
+	track_low = cchh2trk(&f1->DS1EXT1.llimit, geo);
+	track_up = cchh2trk(&f1->DS1EXT1.ulimit, geo);
+
+	printf(" | %44s |          trk |          trk |\n",
+	       s44);
+	printf(" | data set serial number :"	     \
+	       " '%6s'            |"					\
+	       " %12ld | %12ld |\n", s6, track_low, track_up);
+	printf(" | system code            :"   \
+	       " '%13s'     |"						\
+	       "      cyl/trk |      cyl/trk |\n", s13);
+	printf(" | creation date          :"	       \
+	       "  year %4d, day %3d |"				\
+	       " %8d/%3d | %8d/%3d |\n",
+	       f1->DS1CREDT.year + 1900,
+	       f1->DS1CREDT.day,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT1.llimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT1.llimit),
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT1.ulimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT1.ulimit));
+	printf(" +-----------------------------------------"		\
+	       "-----+--------------+--------------+\n");
+}
+
+static void dasdview_print_vtoc_info(dasdview_info_t *info)
 {
         int i;
-	char s6[7], s13[14], s44[45];
-	unsigned long l1 ,l2;
 
 	printf("--- VTOC info --------------------------------" \
 	       "---------------------------------\n");
@@ -703,9 +782,10 @@ dasdview_print_vtoc_info(dasdview_info_t
 	printf("  %d format 4 label(s)\n", info->f4c);
 	printf("  %d format 5 label(s)\n", info->f5c);
 	printf("  %d format 7 label(s)\n", info->f7c);
+	printf("  %d format 8 label(s)\n", info->f8c);
+	printf("  %d format 9 label(s)\n", info->f9c);
 
-	if (info->f1c < 1)
-	{
+	if ((info->f1c < 1) && (info->f8c < 1))	{
 	        printf("There are no partitions defined.\n");
 	} else {
 	        printf("Other S/390 and zSeries operating systems would see " \
@@ -718,59 +798,192 @@ dasdview_print_vtoc_info(dasdview_info_t
 		       "--------------+--------------+\n");
 
 		for (i=0; i<info->f1c; i++)
-		{
-		        bzero(s44, 45);
-			strncpy(s44, info->f1[i].DS1DSNAM, 44);
-			vtoc_ebcdic_dec(s44, s44, 44);
-		        bzero(s6, 7);
-			strncpy(s6, (char *)info->f1[i].DS1DSSN, 6);
-			vtoc_ebcdic_dec(s6, s6, 6);
-		        bzero(s13, 14);
-			strncpy(s13, (char *)info->f1[i].DS1SYSCD, 13);
-			vtoc_ebcdic_dec(s13, s13, 13);
-
-			l1 = (unsigned long) info->f1[i].DS1EXT1.llimit.cc *
-			     (unsigned long) info->geo.heads +
-			     (unsigned long) info->f1[i].DS1EXT1.llimit.hh;
-			l2 = (unsigned long) info->f1[i].DS1EXT1.ulimit.cc *
-			     (unsigned long) info->geo.heads +
-			     (unsigned long) info->f1[i].DS1EXT1.ulimit.hh;
-
-			printf(" | %44s |          trk |          trk |\n",
-			       s44);
-			printf(" | data set serial number :" \
-			       " '%6s'            |" \
-			       " %12ld | %12ld |\n", s6, l1, l2);
-			printf(" | system code            :" \
-			       " '%13s'     |" \
-			       "      cyl/trk |      cyl/trk |\n", s13);
-			printf(" | creation date          :" \
-			       "  year %4d, day %3d |" \
-			       " %8d/%3d | %8d/%3d |\n",
-			       info->f1[i].DS1CREDT.year + 1900,
-			       info->f1[i].DS1CREDT.day,
-			       info->f1[i].DS1EXT1.llimit.cc,
-			       info->f1[i].DS1EXT1.llimit.hh,
-			       info->f1[i].DS1EXT1.ulimit.cc,
-			       info->f1[i].DS1EXT1.ulimit.hh);
-			printf(" +-----------------------------------------" \
-			       "-----+--------------+--------------+\n");
-		}
+			dasdview_print_format1_8_short_info(&info->f1[i],
+							    &info->geo);
+		for (i=0; i<info->f8c; i++)
+			dasdview_print_format1_8_short_info(&info->f8[i],
+							    &info->geo);
 	}
-
 }
 
+/*
+ * Note: the explicit cylinder/head conversion for large volume
+ * adresses should not be necessary for entries that point to
+ * vtoc labels, as those must be located in the first 65K-1 tracks,
+ * but we do it anyway to be on the safe side.
+ */
 
-static void
-dasdview_print_vtoc_f1(dasdview_info_t *info)
+static void dasdview_print_format1_8_full(format1_label_t *f1)
 {
-        int i, j;
 	char s6[7], s13[14], s44[45];
+	int i;
 
 	bzero(s6, 7);
 	bzero(s13, 14);
 	bzero(s44, 45);
 
+	strncpy(s44, f1->DS1DSNAM, 44);
+	printf("DS1DSNAM    : ascii  '%44s'\n", s44);
+	vtoc_ebcdic_dec(s44, s44, 44);
+	printf("              ebcdic '%44s'\n", s44);
+	printf("DS1FMTID    : dec %d, hex %02x\n",
+	       f1->DS1FMTID, f1->DS1FMTID);
+	printf("DS1DSSN     : hex    ");
+	for (i=0; i<6; i++) printf("%02x", f1->DS1DSSN[i]);
+	strncpy(s6, (char *)f1->DS1DSSN, 6);
+	printf("\n              ascii  '%6s'\n", s6);
+	vtoc_ebcdic_dec(s6, s6, 6);
+	printf("              ebcdic '%6s'\n", s6);
+	printf("DS1VOLSQ    : dec %d, hex %04x\n",
+	       f1->DS1VOLSQ, f1->DS1VOLSQ);
+	printf("DS1CREDT    : hex %02x%04x "	\
+	       "(year %d, day %d)\n",
+	       f1->DS1CREDT.year, f1->DS1CREDT.day,
+	       f1->DS1CREDT.year + 1900,
+	       f1->DS1CREDT.day);
+	printf("DS1EXPDT    : hex %02x%04x "	\
+	       "(year %d, day %d)\n",
+	       f1->DS1EXPDT.year, f1->DS1EXPDT.day,
+	       f1->DS1EXPDT.year + 1900,
+	       f1->DS1EXPDT.day);
+	printf("DS1NOEPV    : dec %d, hex %02x\n",
+	       f1->DS1NOEPV, f1->DS1NOEPV);
+	printf("DS1NOBDB    : dec %d, hex %02x\n",
+	       f1->DS1NOBDB, f1->DS1NOBDB);
+	printf("DS1FLAG1    : dec %d, hex %02x\n",
+	       f1->DS1FLAG1, f1->DS1FLAG1);
+	printf("DS1SYSCD    : hex    ");
+	for (i=0; i<13; i++) printf("%02x", f1->DS1SYSCD[i]);
+	strncpy(s13, (char *)f1->DS1SYSCD, 13);
+	printf("\n              ascii  '%13s'\n", s13);
+	vtoc_ebcdic_dec(s13, s13, 13);
+	printf("              ebcdic '%13s'\n", s13);
+	printf("DS1REFD     : hex %02x%04x "	\
+	       "(year %d, day %d)\n",
+	       f1->DS1REFD.year, f1->DS1REFD.day,
+	       f1->DS1REFD.year + 1900,
+	       f1->DS1REFD.day);
+	printf("DS1SMSFG    : dec %d, hex %02x\n",
+	       f1->DS1SMSFG, f1->DS1SMSFG);
+	printf("DS1SCXTF    : dec %d, hex %02x\n",
+	       f1->DS1SCXTF, f1->DS1SCXTF);
+	printf("DS1SCXTV    : dec %d, hex %04x\n",
+	       f1->DS1SCXTV, f1->DS1SCXTV);
+	printf("DS1DSRG1    : dec %d, hex %02x\n",
+	       f1->DS1DSRG1, f1->DS1DSRG1);
+	printf("DS1DSRG2    : dec %d, hex %02x\n",
+	       f1->DS1DSRG2, f1->DS1DSRG2);
+	printf("DS1RECFM    : dec %d, hex %02x\n",
+	       f1->DS1RECFM, f1->DS1RECFM);
+	printf("DS1OPTCD    : dec %d, hex %02x\n",
+	       f1->DS1OPTCD, f1->DS1OPTCD);
+	printf("DS1BLKL     : dec %d, hex %04x\n",
+	       f1->DS1BLKL, f1->DS1BLKL);
+	printf("DS1LRECL    : dec %d, hex %04x\n",
+	       f1->DS1LRECL, f1->DS1LRECL);
+	printf("DS1KEYL     : dec %d, hex %02x\n",
+	       f1->DS1KEYL, f1->DS1KEYL);
+	printf("DS1RKP      : dec %d, hex %04x\n",
+	       f1->DS1RKP, f1->DS1RKP);
+	printf("DS1DSIND    : dec %d, hex %02x\n",
+	       f1->DS1DSIND, f1->DS1DSIND);
+	printf("DS1SCAL1    : dec %d, hex %02x\n",
+	       f1->DS1SCAL1, f1->DS1SCAL1);
+	printf("DS1SCAL3    : hex ");
+	for (i=0; i<3; i++) printf("%02x", f1->DS1SCAL3[i]);
+	printf("\nDS1LSTAR    : hex %04x%02x "	\
+	       "(trk %d, blk %d)\n",
+	       f1->DS1LSTAR.tt, f1->DS1LSTAR.r,
+	       f1->DS1LSTAR.tt, f1->DS1LSTAR.r);
+	printf("DS1TRBAL    : dec %d, hex %04x\n",
+	       f1->DS1TRBAL, f1->DS1TRBAL);
+	printf("reserved    : dec %d, hex %04x\n",
+	       f1->res1, f1->res1);
+	printf("DS1EXT1     : hex %02x%02x%04x%04x%04x%04x\n",
+	       f1->DS1EXT1.typeind,
+	       f1->DS1EXT1.seqno,
+	       f1->DS1EXT1.llimit.cc,
+	       f1->DS1EXT1.llimit.hh,
+	       f1->DS1EXT1.ulimit.cc,
+	       f1->DS1EXT1.ulimit.hh);
+	printf("              typeind    : dec %d, hex %02x\n",
+	       f1->DS1EXT1.typeind,
+	       f1->DS1EXT1.typeind);
+	printf("              seqno      : dec %d, hex %02x\n",
+	       f1->DS1EXT1.seqno, f1->DS1EXT1.seqno);
+	printf("              llimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT1.llimit.cc,
+	       f1->DS1EXT1.llimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT1.llimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT1.llimit));
+	printf("              ulimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT1.ulimit.cc,
+	       f1->DS1EXT1.ulimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT1.ulimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT1.ulimit));
+	printf("DS1EXT2     : hex %02x%02x%04x%04x%04x%04x\n",
+	       f1->DS1EXT2.typeind,
+	       f1->DS1EXT2.seqno,
+	       f1->DS1EXT2.llimit.cc,
+	       f1->DS1EXT2.llimit.hh,
+	       f1->DS1EXT2.ulimit.cc,
+	       f1->DS1EXT2.ulimit.hh);
+	printf("              typeind    : dec %d, hex %02x\n",
+	       f1->DS1EXT2.typeind,
+	       f1->DS1EXT2.typeind);
+	printf("              seqno      : dec %d, hex %02x\n",
+	       f1->DS1EXT2.seqno, f1->DS1EXT2.seqno);
+	printf("              llimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT2.llimit.cc,
+	       f1->DS1EXT2.llimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT2.llimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT2.llimit));
+	printf("              ulimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT2.ulimit.cc,
+	       f1->DS1EXT2.ulimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT2.ulimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT2.ulimit));
+	printf("DS1EXT3     : hex %02x%02x%04x%04x%04x%04x\n",
+	       f1->DS1EXT3.typeind,
+	       f1->DS1EXT3.seqno,
+	       f1->DS1EXT3.llimit.cc,
+	       f1->DS1EXT3.llimit.hh,
+	       f1->DS1EXT3.ulimit.cc,
+	       f1->DS1EXT3.ulimit.hh);
+	printf("              typeind    : dec %d, hex %02x\n",
+	       f1->DS1EXT3.typeind,
+	       f1->DS1EXT3.typeind);
+	printf("              seqno      : dec %d, hex %02x\n",
+	       f1->DS1EXT3.seqno, f1->DS1EXT3.seqno);
+	printf("              llimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT3.llimit.cc,
+	       f1->DS1EXT3.llimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT3.llimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT3.llimit));
+	printf("              ulimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       f1->DS1EXT3.ulimit.cc,
+	       f1->DS1EXT3.ulimit.hh,
+	       vtoc_get_cyl_from_cchh(&f1->DS1EXT3.ulimit),
+	       vtoc_get_head_from_cchh(&f1->DS1EXT3.ulimit));
+	printf("DS1PTRDS    : %04x%04x%02x "		\
+	       "(cyl %d, trk %d, blk %d)\n",
+	       f1->DS1PTRDS.cc, f1->DS1PTRDS.hh,
+	       f1->DS1PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&f1->DS1PTRDS),
+	       vtoc_get_head_from_cchhb(&f1->DS1PTRDS),
+	       f1->DS1PTRDS.b);
+}
+
+static void dasdview_print_vtoc_f1(dasdview_info_t *info)
+{
+        int j;
+
 	printf("--- VTOC format 1 labels ----------------------" \
 	       "---------------------------------\n");
 
@@ -780,163 +993,28 @@ dasdview_print_vtoc_f1(dasdview_info_t *
 		return;
 	}
 
-	for (j=0; j<info->f1c; j++)
+	for (j=0; j<info->f1c; j++) {
+		printf("\n--- format 1 DSCB number %d ---\n", j+1);
+		dasdview_print_format1_8_full(&info->f1[j]);
+	}
+}
+
+static void dasdview_print_vtoc_f8(dasdview_info_t *info)
+{
+        int j;
+
+	printf("--- VTOC format 8 labels ----------------------" \
+	       "---------------------------------\n");
+
+	if (info->f8c < 1)
 	{
-	        printf("\n--- format 1 DSCB number %d ---\n", j+1);
-		strncpy(s44, info->f1[j].DS1DSNAM, 44);
-		printf("DS1DSNAM    : ascii  '%44s'\n", s44);
-		vtoc_ebcdic_dec(s44, s44, 44);
-		printf("              ebcdic '%44s'\n", s44);
-		printf("DS1FMTID    : dec %d, hex %02x\n",
-		       info->f1[j].DS1FMTID, info->f1[j].DS1FMTID);
-		printf("DS1DSSN     : hex    ");
-		for (i=0; i<6; i++) printf("%02x", info->f1[j].DS1DSSN[i]);
-		strncpy(s6, (char *)info->f1[j].DS1DSSN, 6);
-		printf("\n              ascii  '%6s'\n", s6);
-		vtoc_ebcdic_dec(s6, s6, 6);
-		printf("              ebcdic '%6s'\n", s6);
-		printf("DS1VOLSQ    : dec %d, hex %04x\n",
-		       info->f1[j].DS1VOLSQ, info->f1[j].DS1VOLSQ);
-		printf("DS1CREDT    : hex %02x%04x " \
-		       "(year %d, day %d)\n",
-		       info->f1[j].DS1CREDT.year, info->f1[j].DS1CREDT.day,
-		       info->f1[j].DS1CREDT.year + 1900,
-		       info->f1[j].DS1CREDT.day);
-		printf("DS1EXPDT    : hex %02x%04x " \
-		       "(year %d, day %d)\n",
-		       info->f1[j].DS1EXPDT.year, info->f1[j].DS1EXPDT.day,
-		       info->f1[j].DS1EXPDT.year + 1900,
-		       info->f1[j].DS1EXPDT.day);
-		printf("DS1NOEPV    : dec %d, hex %02x\n",
-		       info->f1[j].DS1NOEPV, info->f1[j].DS1NOEPV);
-		printf("DS1NOBDB    : dec %d, hex %02x\n",
-		       info->f1[j].DS1NOBDB, info->f1[j].DS1NOBDB);
-		printf("DS1FLAG1    : dec %d, hex %02x\n",
-		       info->f1[j].DS1FLAG1, info->f1[j].DS1FLAG1);
-		printf("DS1SYSCD    : hex    ");
-		for (i=0; i<13; i++) printf("%02x", info->f1[j].DS1SYSCD[i]);
-		strncpy(s13, (char *)info->f1[j].DS1SYSCD, 13);
-		printf("\n              ascii  '%13s'\n", s13);
-		vtoc_ebcdic_dec(s13, s13, 13);
-		printf("              ebcdic '%13s'\n", s13);
-		printf("DS1REFD     : hex %02x%04x " \
-		       "(year %d, day %d)\n",
-		       info->f1[j].DS1REFD.year, info->f1[j].DS1REFD.day,
-		       info->f1[j].DS1REFD.year + 1900,
-		       info->f1[j].DS1REFD.day);
-		printf("DS1SMSFG    : dec %d, hex %02x\n",
-		       info->f1[j].DS1SMSFG, info->f1[j].DS1SMSFG);
-		printf("DS1SCXTF    : dec %d, hex %02x\n",
-		       info->f1[j].DS1SCXTF, info->f1[j].DS1SCXTF);
-		printf("DS1SCXTV    : dec %d, hex %04x\n",
-		       info->f1[j].DS1SCXTV, info->f1[j].DS1SCXTV);
-		printf("DS1DSRG1    : dec %d, hex %02x\n",
-		       info->f1[j].DS1DSRG1, info->f1[j].DS1DSRG1);
-		printf("DS1DSRG2    : dec %d, hex %02x\n",
-		       info->f1[j].DS1DSRG2, info->f1[j].DS1DSRG2);
-		printf("DS1RECFM    : dec %d, hex %02x\n",
-		       info->f1[j].DS1RECFM, info->f1[j].DS1RECFM);
-		printf("DS1OPTCD    : dec %d, hex %02x\n",
-		       info->f1[j].DS1OPTCD, info->f1[j].DS1OPTCD);
-		printf("DS1BLKL     : dec %d, hex %04x\n",
-		       info->f1[j].DS1BLKL, info->f1[j].DS1BLKL);
-		printf("DS1LRECL    : dec %d, hex %04x\n",
-		       info->f1[j].DS1LRECL, info->f1[j].DS1LRECL);
-		printf("DS1KEYL     : dec %d, hex %02x\n",
-		       info->f1[j].DS1KEYL, info->f1[j].DS1KEYL);
-		printf("DS1RKP      : dec %d, hex %04x\n",
-		       info->f1[j].DS1RKP, info->f1[j].DS1RKP);
-		printf("DS1DSIND    : dec %d, hex %02x\n",
-		       info->f1[j].DS1DSIND, info->f1[j].DS1DSIND);
-		printf("DS1SCAL1    : dec %d, hex %02x\n",
-		       info->f1[j].DS1SCAL1, info->f1[j].DS1SCAL1);
-		printf("DS1SCAL3    : hex ");
-		for (i=0; i<3; i++) printf("%02x", info->f1[j].DS1SCAL3[i]);
-		printf("\nDS1LSTAR    : hex %04x%02x " \
-		       "(trk %d, blk %d)\n",
-		       info->f1[j].DS1LSTAR.tt, info->f1[j].DS1LSTAR.r,
-		       info->f1[j].DS1LSTAR.tt, info->f1[j].DS1LSTAR.r);
-		printf("DS1TRBAL    : dec %d, hex %04x\n",
-		       info->f1[j].DS1TRBAL, info->f1[j].DS1TRBAL);
-		printf("reserved    : dec %d, hex %04x\n",
-		       info->f1[j].res1, info->f1[j].res1);
-		printf("DS1EXT1     : hex %02x%02x%04x%04x%04x%04x\n",
-		       info->f1[j].DS1EXT1.typeind,
-		       info->f1[j].DS1EXT1.seqno,
-		       info->f1[j].DS1EXT1.llimit.cc,
-		       info->f1[j].DS1EXT1.llimit.hh,
-		       info->f1[j].DS1EXT1.ulimit.cc,
-		       info->f1[j].DS1EXT1.ulimit.hh);
-		printf("              typeind    : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT1.typeind,
-		       info->f1[j].DS1EXT1.typeind);
-		printf("              seqno      : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT1.seqno, info->f1[j].DS1EXT1.seqno);
-		printf("              llimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT1.llimit.cc,
-		       info->f1[j].DS1EXT1.llimit.hh,
-		       info->f1[j].DS1EXT1.llimit.cc,
-		       info->f1[j].DS1EXT1.llimit.hh);
-		printf("              ulimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT1.ulimit.cc,
-		       info->f1[j].DS1EXT1.ulimit.hh,
-		       info->f1[j].DS1EXT1.ulimit.cc,
-		       info->f1[j].DS1EXT1.ulimit.hh);
-		printf("DS1EXT2     : hex %02x%02x%04x%04x%04x%04x\n",
-		       info->f1[j].DS1EXT2.typeind,
-		       info->f1[j].DS1EXT2.seqno,
-		       info->f1[j].DS1EXT2.llimit.cc,
-		       info->f1[j].DS1EXT2.llimit.hh,
-		       info->f1[j].DS1EXT2.ulimit.cc,
-		       info->f1[j].DS1EXT2.ulimit.hh);
-		printf("              typeind    : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT2.typeind,
-		       info->f1[j].DS1EXT2.typeind);
-		printf("              seqno      : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT2.seqno, info->f1[j].DS1EXT2.seqno);
-		printf("              llimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT2.llimit.cc,
-		       info->f1[j].DS1EXT2.llimit.hh,
-		       info->f1[j].DS1EXT2.llimit.cc,
-		       info->f1[j].DS1EXT2.llimit.hh);
-		printf("              ulimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT2.ulimit.cc,
-		       info->f1[j].DS1EXT2.ulimit.hh,
-		       info->f1[j].DS1EXT2.ulimit.cc,
-		       info->f1[j].DS1EXT2.ulimit.hh);
-		printf("DS1EXT3     : hex %02x%02x%04x%04x%04x%04x\n",
-		       info->f1[j].DS1EXT3.typeind,
-		       info->f1[j].DS1EXT3.seqno,
-		       info->f1[j].DS1EXT3.llimit.cc,
-		       info->f1[j].DS1EXT3.llimit.hh,
-		       info->f1[j].DS1EXT3.ulimit.cc,
-		       info->f1[j].DS1EXT3.ulimit.hh);
-		printf("              typeind    : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT3.typeind,
-		       info->f1[j].DS1EXT3.typeind);
-		printf("              seqno      : dec %d, hex %02x\n",
-		       info->f1[j].DS1EXT3.seqno, info->f1[j].DS1EXT3.seqno);
-		printf("              llimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT3.llimit.cc,
-		       info->f1[j].DS1EXT3.llimit.hh,
-		       info->f1[j].DS1EXT3.llimit.cc,
-		       info->f1[j].DS1EXT3.llimit.hh);
-		printf("              ulimit     : hex %04x%04x " \
-		       "(cyl %d, trk %d)\n",
-		       info->f1[j].DS1EXT3.ulimit.cc,
-		       info->f1[j].DS1EXT3.ulimit.hh,
-		       info->f1[j].DS1EXT3.ulimit.cc,
-		       info->f1[j].DS1EXT3.ulimit.hh);
-		printf("DS1PTRDS    : %04x%04x%02x " \
-		       "(cyl %d, trk %d, blk %d)\n",
-		       info->f1[j].DS1PTRDS.cc, info->f1[j].DS1PTRDS.hh,
-		       info->f1[j].DS1PTRDS.b,  info->f1[j].DS1PTRDS.cc,
-		       info->f1[j].DS1PTRDS.hh, info->f1[j].DS1PTRDS.b);
+	        printf("This VTOC doesn't contain a format 8 label.\n");
+		return;
+	}
+
+	for (j=0; j<info->f8c; j++) {
+		printf("\n--- format 8 DSCB number %d ---\n", j+1);
+		dasdview_print_format1_8_full(&info->f8[j]);
 	}
 }
 
@@ -961,13 +1039,16 @@ dasdview_print_vtoc_f4(dasdview_info_t *
 	printf("DS4HPCHR    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
 	       info->f4.DS4HPCHR.cc, info->f4.DS4HPCHR.hh,
-	       info->f4.DS4HPCHR.b,  info->f4.DS4HPCHR.cc,
-	       info->f4.DS4HPCHR.hh, info->f4.DS4HPCHR.b);
+	       info->f4.DS4HPCHR.b,
+	       vtoc_get_cyl_from_cchhb(&info->f4.DS4HPCHR),
+	       vtoc_get_head_from_cchhb(&info->f4.DS4HPCHR),
+	       info->f4.DS4HPCHR.b);
 	printf("DS4DSREC    : dec %d, hex %04x\n",
 	       info->f4.DS4DSREC, info->f4.DS4DSREC);
 	printf("DS4HCCHH    : %04x%04x (cyl %d, trk %d)\n",
 	       info->f4.DS4HCCHH.cc, info->f4.DS4HCCHH.hh,
-	       info->f4.DS4HCCHH.cc, info->f4.DS4HCCHH.hh);
+	       vtoc_get_cyl_from_cchh(&info->f4.DS4HCCHH),
+	       vtoc_get_head_from_cchh(&info->f4.DS4HCCHH));
 	printf("DS4NOATK    : dec %d, hex %04x\n",
 	       info->f4.DS4NOATK, info->f4.DS4NOATK);
 	printf("DS4VTOCI    : dec %d, hex %02x\n",
@@ -1018,10 +1099,12 @@ dasdview_print_vtoc_f4(dasdview_info_t *
 	       info->f4.DS4VTOCE.seqno, info->f4.DS4VTOCE.seqno);
 	printf("              llimit     : hex %04x%04x (cyl %d, trk %d)\n",
 	       info->f4.DS4VTOCE.llimit.cc, info->f4.DS4VTOCE.llimit.hh,
-	       info->f4.DS4VTOCE.llimit.cc, info->f4.DS4VTOCE.llimit.hh);
+	       vtoc_get_cyl_from_cchh(&info->f4.DS4VTOCE.llimit),
+	       vtoc_get_head_from_cchh(&info->f4.DS4VTOCE.llimit));
 	printf("              ulimit     : hex %04x%04x (cyl %d, trk %d)\n",
 	       info->f4.DS4VTOCE.ulimit.cc, info->f4.DS4VTOCE.ulimit.hh,
-	       info->f4.DS4VTOCE.ulimit.cc, info->f4.DS4VTOCE.ulimit.hh);
+	       vtoc_get_cyl_from_cchh(&info->f4.DS4VTOCE.ulimit),
+	       vtoc_get_head_from_cchh(&info->f4.DS4VTOCE.ulimit));
 	printf("res2        : hex ");
 	for (i=0; i<10; i++) printf("%02x", info->f4.res2[i]);
 	printf("\nDS4EFLVL    : dec %d, hex %02x\n",
@@ -1029,11 +1112,18 @@ dasdview_print_vtoc_f4(dasdview_info_t *
 	printf("DS4EFPTR    : hex %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
 	       info->f4.DS4EFPTR.cc, info->f4.DS4EFPTR.hh,
-	       info->f4.DS4EFPTR.b,  info->f4.DS4EFPTR.cc,
-	       info->f4.DS4EFPTR.hh, info->f4.DS4EFPTR.b);
-	printf("res3        : hex ");
-	for (i=0; i<9; i++) printf("%02x", info->f4.res3[i]);
-	printf("\n");
+	       info->f4.DS4EFPTR.b,
+	       vtoc_get_cyl_from_cchhb(&info->f4.DS4EFPTR),
+	       vtoc_get_head_from_cchhb(&info->f4.DS4EFPTR),
+	       info->f4.DS4EFPTR.b);
+	printf("res3        : hex %02x\n", info->f4.res3);
+	printf("DS4DCYL     : dec %d, hex %08x\n",
+	       info->f4.DS4DCYL, info->f4.DS4DCYL);
+	printf("res4        : hex ");
+	for (i=0; i<2; i++) printf("%02x", info->f4.res4[i]);
+	printf("\nDS4DEVF2    : dec %d, hex %02x\n",
+	       info->f4.DS4DEVF2, info->f4.DS4DEVF2);
+	printf("res5        : hex %02x\n", info->f4.res5);
 }
 
 static void
@@ -1083,8 +1173,10 @@ dasdview_print_vtoc_f5(dasdview_info_t *
 	       "        DS5PTRDS    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
 	       info->f5.DS5PTRDS.cc, info->f5.DS5PTRDS.hh,
-	       info->f5.DS5PTRDS.b,  info->f5.DS5PTRDS.cc,
-	       info->f5.DS5PTRDS.hh, info->f5.DS5PTRDS.b);
+	       info->f5.DS5PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&info->f5.DS5PTRDS),
+	       vtoc_get_head_from_cchhb(&info->f5.DS5PTRDS),
+	       info->f5.DS5PTRDS.b);
 }
 
 static void
@@ -1128,10 +1220,59 @@ dasdview_print_vtoc_f7(dasdview_info_t *
 	       "        DS7PTRDS    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
 	       info->f7.DS7PTRDS.cc, info->f7.DS7PTRDS.hh,
-	       info->f7.DS7PTRDS.b, info->f7.DS7PTRDS.cc,
-	       info->f7.DS7PTRDS.hh, info->f7.DS7PTRDS.b);
+	       info->f7.DS7PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&info->f7.DS7PTRDS),
+	       vtoc_get_head_from_cchhb(&info->f7.DS7PTRDS),
+	       info->f7.DS7PTRDS.b);
 }
 
+static void
+dasdview_print_vtoc_f9(dasdview_info_t *info)
+{
+        int i,j;
+
+	printf("\n--- VTOC format 9 label ----------------------" \
+	       "---------------------------------\n");
+
+	if (info->f9c < 1)
+	{
+	        printf("This VTOC doesn't contain a format 9 label.\n");
+		return;
+	}
+
+	for (j=0; j<info->f9c; j++) {
+		printf("\n--- format 9 DSCB number %d ---\n", j+1);
+		printf("DS9KEYID    : dec %d, hex %02x\n",
+		       info->f9[j].DS9KEYID, info->f9[j].DS9KEYID);
+		printf("DS9SUBTY    : dec %d, hex %02x\n",
+		       info->f9[j].DS9SUBTY, info->f9[j].DS9SUBTY);
+		printf("DS9NUMF9    : dec %d, hex %02x\n",
+		       info->f9[j].DS9NUMF9, info->f9[j].DS9NUMF9);
+
+		printf("res1        : hex ");
+		for (i=0; i < sizeof(info->f9[j].res1); i++) {
+			if ( (i > 0) && (i % 16 == 0) )
+				printf("\n                  ");
+			printf("%02x", info->f9[j].res1[i]);
+			if ( (i+9) % 16 == 0 )
+				printf(" ");
+		}
+		printf("\n");
+
+		printf("DS9FMTID    : dec %d, hex %02x\n",
+		       info->f9[j].DS9FMTID, info->f9[j].DS9FMTID);
+
+		printf("res2        : hex ");
+		for (i=0; i < sizeof(info->f9[j].res2); i++) {
+			if ( (i > 0) && (i % 16 == 0) )
+				printf("\n                  ");
+			printf("%02x", info->f9[j].res2[i]);
+			if ( (i+9) % 16 == 0 )
+				printf(" ");
+		}
+		printf("\n");
+	}
+}
 
 static int
 dasdview_print_format1(unsigned int size, unsigned char *dumpstr)
@@ -1340,6 +1481,15 @@ dasdview_view(dasdview_info_t *info)
 	return 0;
 }
 
+static void
+dasdview_print_characteristic(dasdview_info_t *info)
+{
+		 dasd_information2_t dasd_info;
+		 dasd_info = info->dasd_info;
+		 printf("encrypted disk         : %s\n",
+			(dasd_info.characteristics[46]&0x80) ? "yes" : "no");
+}
+
 
 int main(int argc, char * argv[]) {
 
@@ -1418,6 +1568,10 @@ int main(int argc, char * argv[]) {
 		                info.vtoc_f5 = 1;
 		        else if (strncmp(optarg,"f7",2)==0)
 		                info.vtoc_f7 = 1;
+		        else if (strncmp(optarg,"f8",2)==0)
+		                info.vtoc_f8 = 1;
+		        else if (strncmp(optarg,"f9",2)==0)
+		                info.vtoc_f9 = 1;
 		        else if (strncmp(optarg,"all",3)==0)
 		                info.vtoc_all = 1;
 		        else
@@ -1430,6 +1584,10 @@ int main(int argc, char * argv[]) {
 		        info.vtoc = 1;
 			info.action_specified = 1;
 			break;
+		case 'c':
+			info.action_specified = 1;
+			info.characteristic_specified = 1;
+			break;
 		case 'l':
 			info.action_specified = 1;
 			info.vlabel_info = 1;
